/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAdsStaticDtoAuthorizerAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAdsStaticDtoAuthorizerAllOf{}

// GoogleAdsStaticDtoAuthorizerAllOf struct for GoogleAdsStaticDtoAuthorizerAllOf
type GoogleAdsStaticDtoAuthorizerAllOf struct {
	Label            *string `json:"label,omitempty"`
	ClientId         *string `json:"clientId,omitempty"`
	ClientSecret     *string `json:"clientSecret,omitempty"`
	RedirectUri      *string `json:"redirectUri,omitempty"`
	DeveloperToken   *string `json:"developerToken,omitempty"`
	ClientCustomerId *string `json:"clientCustomerId,omitempty"`
}

// NewGoogleAdsStaticDtoAuthorizerAllOf instantiates a new GoogleAdsStaticDtoAuthorizerAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAdsStaticDtoAuthorizerAllOf() *GoogleAdsStaticDtoAuthorizerAllOf {
	this := GoogleAdsStaticDtoAuthorizerAllOf{}
	return &this
}

// NewGoogleAdsStaticDtoAuthorizerAllOfWithDefaults instantiates a new GoogleAdsStaticDtoAuthorizerAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAdsStaticDtoAuthorizerAllOfWithDefaults() *GoogleAdsStaticDtoAuthorizerAllOf {
	this := GoogleAdsStaticDtoAuthorizerAllOf{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

// GetDeveloperToken returns the DeveloperToken field value if set, zero value otherwise.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetDeveloperToken() string {
	if o == nil || IsNil(o.DeveloperToken) {
		var ret string
		return ret
	}
	return *o.DeveloperToken
}

// GetDeveloperTokenOk returns a tuple with the DeveloperToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetDeveloperTokenOk() (*string, bool) {
	if o == nil || IsNil(o.DeveloperToken) {
		return nil, false
	}
	return o.DeveloperToken, true
}

// HasDeveloperToken returns a boolean if a field has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) HasDeveloperToken() bool {
	if o != nil && !IsNil(o.DeveloperToken) {
		return true
	}

	return false
}

// SetDeveloperToken gets a reference to the given string and assigns it to the DeveloperToken field.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) SetDeveloperToken(v string) {
	o.DeveloperToken = &v
}

// GetClientCustomerId returns the ClientCustomerId field value if set, zero value otherwise.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetClientCustomerId() string {
	if o == nil || IsNil(o.ClientCustomerId) {
		var ret string
		return ret
	}
	return *o.ClientCustomerId
}

// GetClientCustomerIdOk returns a tuple with the ClientCustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) GetClientCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientCustomerId) {
		return nil, false
	}
	return o.ClientCustomerId, true
}

// HasClientCustomerId returns a boolean if a field has been set.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) HasClientCustomerId() bool {
	if o != nil && !IsNil(o.ClientCustomerId) {
		return true
	}

	return false
}

// SetClientCustomerId gets a reference to the given string and assigns it to the ClientCustomerId field.
func (o *GoogleAdsStaticDtoAuthorizerAllOf) SetClientCustomerId(v string) {
	o.ClientCustomerId = &v
}

func (o GoogleAdsStaticDtoAuthorizerAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAdsStaticDtoAuthorizerAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	if !IsNil(o.DeveloperToken) {
		toSerialize["developerToken"] = o.DeveloperToken
	}
	if !IsNil(o.ClientCustomerId) {
		toSerialize["clientCustomerId"] = o.ClientCustomerId
	}
	return toSerialize, nil
}

type NullableGoogleAdsStaticDtoAuthorizerAllOf struct {
	value *GoogleAdsStaticDtoAuthorizerAllOf
	isSet bool
}

func (v NullableGoogleAdsStaticDtoAuthorizerAllOf) Get() *GoogleAdsStaticDtoAuthorizerAllOf {
	return v.value
}

func (v *NullableGoogleAdsStaticDtoAuthorizerAllOf) Set(val *GoogleAdsStaticDtoAuthorizerAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAdsStaticDtoAuthorizerAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAdsStaticDtoAuthorizerAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAdsStaticDtoAuthorizerAllOf(val *GoogleAdsStaticDtoAuthorizerAllOf) *NullableGoogleAdsStaticDtoAuthorizerAllOf {
	return &NullableGoogleAdsStaticDtoAuthorizerAllOf{value: val, isSet: true}
}

func (v NullableGoogleAdsStaticDtoAuthorizerAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAdsStaticDtoAuthorizerAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
